/*********************************************************************
*  192GC02 QVGAJ[OtBbNLCDƃ^b`XN[̃eXg
*@240x320hbg@16rbgJ[ u\
*@vWFNgF Screen2
*  PIC24Fœ쎎
*********************************************************************/
#include "p24FJ64GA002.h"
#include "colorlcd_lib24F.h"
#include <stdlib.h>

// RtBM[Vݒ
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx1 ) 
_CONFIG2( IESO_OFF & FNOSC_FRCPLL & FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_ON & I2C1SEL_PRI & POSCMOD_NONE)


/* O[oϐ`  */
int i, Xset, Yset, Xold, Yold, Count;
unsigned short Getscreen(unsigned short chn);

/*********** C[` ***************/
int main(void)
{
    	// Setup PortA IOs as digital
	CLKDIV = 0;					// Clock devider off
	// Setup PORT In/Out
	TRISA = 0xFFEC;				// RA0,1,RA4 output
	TRISB = 0x000F;				// RB0-3 is input
	// ADC̐ݒ
	AD1CON1 = 0x0000;				// Turn off, manual sample start
	AD1CON2 = 0;					// AVdd, AVss, int every conversion, MUXA only
	AD1CON3 = 0x1F64;				// 31Tad auto-sample, Tad = 50*Tcy
 	AD1CHS = 0x0000;				// Channel select Lower 4bits
	AD1PCFG = 0xFFFC;				// RA0-1 only analog 
	AD1CSSL = 0;					// No scanned inputs
	AD1CON1bits.ADON = 1;			// Start A/D
	// t\̏ƊJnbZ[W\
	lcd_Init();
	Count = 0;
	/****** C [v  *******/
 	while(1){
		/*** bZ[Wo ***/
		delay_ms(100);
		lcd_Clear(BLACK);	
		lcd_Str(0, 16, "Start Drawing", GREEN, BLACK);
		/*** Draw free line ***/
		while(PORTBbits.RB2 != 0){
			/*** XW ****/
			TRISAbits.TRISA1 = 0;		// RB0, RB1 is output
			TRISBbits.TRISB1 = 0;
			LATAbits.LATA1 = 0;		// Set Voltage
			LATBbits.LATB1 = 1;
			TRISAbits.TRISA0 = 1;		// RA0,RA1 input
			TRISBbits.TRISB0 = 1;
			delay_us(30);				// [d҂
			Xset = Getscreen(0);		// Wl擾
			/**** YẂ@****/
			TRISBbits.TRISB0 = 0;		// RA0,RA1 output
			TRISAbits.TRISA0 = 0;
			LATAbits.LATA0 = 0;		// Set Voltage
			LATBbits.LATB0 = 1;
			TRISAbits.TRISA1 = 1;		// RB0, RB1 is input
			TRISBbits.TRISB1 = 1;
			delay_us(30);				// [d҂
			Yset = Getscreen(1);		// Wl擾
			/*** ŏ̗オ蕔̉ ***/
			if((abs(Xset - Xold) < 2) && abs(Yset - Yold) < 2){
				Count++;
				if(Count >= 8){
					/*** `@****/
					lcd_Pixel((710- Xset)/2, (Yset-85)*2/5, YELLOW);
					Count = 0;
				}
			}
			else
				Count = 0;

			Xold = Xset;
			Yold = Yset;
		}
	}
}

unsigned short Getscreen(unsigned short chn)
{
	AD1CON1bits.ADON = 0;
	AD1CHS = chn;					// Select Channel
	AD1CON1bits.ADON = 1;
	AD1CON1bits.SAMP = 1;
	delay_us(10);					// Wait Aquisition
	AD1CON1bits.SAMP = 0;			// A/D convert start
	while(!AD1CON1bits.DONE);		// wait conversion
	return(ADC1BUF0);				// rturn result
}

			


